"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

exports.parseArgs = parseArgs;
exports.cypherDirectiveArgs = cypherDirectiveArgs;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseArgs(args) {
  if (!args) {
    return {};
  }

  if (args.length === 0) {
    return {};
  }

  return args.reduce(function (acc, arg) {

    switch (arg.value.kind) {
      case "IntValue":
        acc[arg.name.value] = parseInt(arg.value.value);
        break;
      case "FloatValue":
        acc[arg.name.value] = parseFloat(arg.value.value);
        break;
      default:
        acc[arg.name.value] = arg.value.value;
    }

    return acc;
  }, {});
}

function getDefaultArguments(fieldName, schemaType) {
  // FIXME: check that these things exist

  try {
    return schemaType._fields[fieldName].args.reduce(function (acc, arg) {
      acc[arg.name] = arg.defaultValue;
      return acc;
    }, {});
  } catch (err) {
    return {};
  }
}

function cypherDirectiveArgs(variable, headSelection, schemaType) {
  var defaultArgs = getDefaultArguments(headSelection.name.value, schemaType); //{"this": variable};
  var schemaArgs = {}; // FIXME: what's the differenc between schemargs and defaultargs?
  var queryArgs = parseArgs(headSelection.arguments);
  console.log(queryArgs);

  var args = (0, _stringify2.default)((0, _assign2.default)(defaultArgs, queryArgs)).replace(/\"([^(\")"]+)\":/g, " $1: ");

  return args === "{}" ? "{this: " + variable + args.substring(1) : "{this: " + variable + "," + args.substring(1);
}